/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.uinfo.salix;

import org.apache.log4j.Logger;
import org.dive4elements.artifactdatabase.state.Facet;
import org.dive4elements.river.artifacts.common.ResultFacet;
import org.dive4elements.river.artifacts.states.DefaultState.ComputeType;

/**
 * Facet of the U-Info salix rank areas.
 */
public class SalixRankResultFacet extends ResultFacet {

    private static final long serialVersionUID = 1L;

    private static Logger log = Logger.getLogger(SalixRankResultFacet.class);

    public SalixRankResultFacet() {
        // required for clone operation deepCopy()
    }

    public SalixRankResultFacet(final int facetIndex, final int resultIndex, final String name, final String description, final String yAxisLabelKey,
            final String stateId, final String hash) {
        super(facetIndex, resultIndex, name, description, yAxisLabelKey, ComputeType.ADVANCE, stateId, hash);
    }

    /** Copy deeply. */
    @Override
    public Facet deepCopy() {
        // FIXME: why not simply use the full constructor instead?
        final SalixRankResultFacet copy = new SalixRankResultFacet();
        // FIXME: why does DataFacet does not override set? Bad access to variables of parent!
        copy.set(this);
        copy.type = this.type;
        copy.hash = this.hash;
        copy.stateId = this.stateId;
        return copy;
    }
}